VERSION 5.00
Begin VB.Form FHookMove 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "FHookMove"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 2002 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

' Win32 API Declarations
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Const WM_MOVE = &H3
Private Const WM_MOVING = &H216

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

' ********************************************
'  Event handlers
' ********************************************
Private Sub Form_Load()
   ' *** Remember: Set "obj" variable in MHookMe.HookFunc
   ' *** to early-bind with this object!!!
   Call HookWindow(Me.hWnd, Me)
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call UnhookWindow(Me.hWnd)
End Sub

' ********************************************
'  Subclassing
' ********************************************
Friend Function WindowProc(hWnd As Long, msg As Long, wp As Long, lp As Long) As Long
   Dim Result As Long
   Dim r As RECT
   Static BeenHere As Boolean
   Static dX As Long
   Static dY As Long
   
   If Not BeenHere Then
      ' Precalculate and store screen dimensions.
      dX = Screen.Width \ Screen.TwipsPerPixelX
      dY = Screen.Height \ Screen.TwipsPerPixelY
      BeenHere = True
   End If
   
   Select Case msg
      Case WM_MOVING
         ' Grab screen coordinates of drag rectangle.
         Call CopyMemory(r, ByVal lp, Len(r))
         ' Adjust to prevent window from going offscreen.
         If r.Left < 0 Then
            r.Right = r.Right - r.Left
            r.Left = 0
         End If
         If r.Top < 0 Then
            r.Bottom = r.Bottom - r.Top
            r.Top = 0
         End If
         If r.Right > dX Then
            r.Left = dX - (r.Right - r.Left)
            r.Right = dX
         End If
         If r.Bottom > dY Then
            r.Top = dY - (r.Bottom - r.Top)
            r.Bottom = dY
         End If
         ' Update drag rectangle for Windows.
         Call CopyMemory(ByVal lp, r, Len(r))
         ' Let Windows know we've handled this.
         Result = True
      
      Case Else
         ' Pass along to default window procedure.
         Result = InvokeWindowProc(hWnd, msg, wp, lp)
   End Select
   
   ' Return desired result code to Windows.
   WindowProc = Result
End Function


